module Engine.ExperimentResult
( ExperimentResult(..)
, RanExperiment(..)
, remapExperimentResult
) where

import Bottom
import Control.Exception
import Data.Map (Map)
import Data.Maybe
import Data.Sequence (Seq)
import Plan
import qualified Data.Map as Map
import Engine.EngineHValue

data ExperimentResult 
  = Redundant !(Seq Experiment)
  | Ok 
  | Errors    !SomeException
  | Bottoms   !BottomId
  | Property  !Bool
  | Show      !String

data RanExperiment
  = NewResult     { getExperimentResult :: !ExperimentResult
                  , experimentRTValue   :: !(Maybe EngineHValue) 
                  }
  | CachedResult  { getExperimentResult :: !ExperimentResult 
                  , experimentRTValue   :: !(Maybe EngineHValue)
                  }

remapExperimentResult :: Map BottomId BottomId -> ExperimentResult ->  ExperimentResult
remapExperimentResult mp (Bottoms bid) = Bottoms . fromMaybe (error "remapExperimentResult - E") . Map.lookup bid $ mp
remapExperimentResult _ er = er
