module Util.BiMap where

import Data.Map (Map)
import qualified Data.Map as Map
import Data.Monoid

data BiMap a b = BiMap { forwardMap :: Map a b
                       , inverseMap :: Map b a
                       }

empty :: BiMap a b 
empty = BiMap { forwardMap = Map.empty
              , inverseMap = Map.empty
              }

singleton :: (Ord a, Ord b) => a -> b -> BiMap a b
singleton a b = BiMap { forwardMap = Map.singleton a b
                      , inverseMap = Map.singleton b a
                      }


instance (Ord a, Ord b) => Monoid (BiMap a b) where
  mempty = empty
  mappend (BiMap l1 l2) (BiMap r1 r2) = BiMap (l1 `mappend` r1) (l2 `mappend` r2)
