{-# LANGUAGE BangPatterns #-}
module Util.StrictMaybe
( Maybe(..)
, First(..)
, maybe
) where

import Prelude hiding (Maybe(..), maybe)
import Data.Monoid hiding (First(..))

data Maybe a
  = Nothing
  | Just !a

maybe :: b -> (a -> b) -> Maybe a -> b
maybe d _ Nothing  = d
maybe _ f (Just x) = f x

instance Monoid a => Monoid (Maybe a) where
  mempty = Nothing

  Nothing `mappend` x         = x
  x `mappend` Nothing         = x
  (Just x) `mappend` (Just y) = Just (x `mappend` y)

newtype First a = First { getFirst :: Maybe a }

instance Monoid (First a) where
  mempty = First Nothing
  l1@(First (Just _)) `mappend` _  = l1
  _                   `mappend` l2 = l2
